searchNodes=[{"ref":"Brook.html","title":"Brook","type":"module","doc":"Brook provides an event stream client interface for distributed applications to communicate indirectly and asynchronously. Brook sends and receives messages with the event stream (typically a message queue service) via a driver module and persists an application-specific view of the event stream via a storage module (defaulting to ETS). Sample Configuration Brook is configured within the application environment by defining a keyword list with three primary keys: driver, handler, and storage. config :my_app, :brook, driver: [ module: Brook.Driver.Json, init_arg: [] ], handler: [MyApp.Event.Handler], storage: [ modules: Brook.Storage.Ets, init_arg: [] ] Driver The Brook driver implements a behaviour that sends messages to the event stream. Events are Brook structs that contain an event type, an author (or source), a creation timestamp, the event data, and an ack reference and ack data (following the lead of the broadway library.) The default driver sends the event message to the Brook server via Genserver.cast Additional drivers provided at this time are a json-encoding version of the default driver and a Kafka driver using the elsa library. Handler The Brook handler implements a behaviour that provides a handle_event/1 function. Handlers receive a Brook event and take appropriate action according to the implementing application&#39;s business logic. Applications implement as many function heads for the event handler as necessary and return one of four tuples depending on how the storage module should treat the event with respect to persistence. Events can: create a record in the view state via the {:create, collection, key, value} return update an existing record via the {:merge, collection, key, value} return delete a record via the {:delete, collection, key} return discard the record and do not effect the persistent view via the :discard return Storage The Brook storage module implements yet another behaviour that persists event data to an application view state specific to the application importing the Brook library, allowing the application to only store information received from the event stream that is relevant to its own domain and retrieve it when necessary. Storage modules implement basic CRUD operations that correlate to the return values of the event handler module. The default module uses ETS for fast, local, in-memory storage and retrieval (great for testing purposes!) with an additional Redis-based module as well."},{"ref":"Brook.html#child_spec/1","title":"Brook.child_spec/1","type":"function","doc":"Provides a Brook Supervisor child spec for defining a custom Brook supervisor."},{"ref":"Brook.html#get/3","title":"Brook.get/3","type":"function","doc":"Return an item from the Brook view state for the implementing application wrapped in an :ok tuple or else an :error tuple with a reason."},{"ref":"Brook.html#get!/3","title":"Brook.get!/3","type":"function","doc":"Returns the value stored under the given key and collection from the Brook view state or else raises an exception."},{"ref":"Brook.html#get_all/2","title":"Brook.get_all/2","type":"function","doc":"Return all values saved to the Brook view state for a given collection, wrapped in an :ok tuple or else an :error tuple with reason. Values are returned as a map where the keys are the keys used to index the saved values and the values are anything saved under a given key based on processing events."},{"ref":"Brook.html#get_all!/2","title":"Brook.get_all!/2","type":"function","doc":"Return all values saved to the Brook view state for a given collection or else raises an exception. Values are returned as a map where the keys are the keys used to index the saved values and the values are anything saved under a given key."},{"ref":"Brook.html#get_all_values/2","title":"Brook.get_all_values/2","type":"function","doc":"Returns a list of all values saved to a given collection of the Brook view state, indepentent of the key used to index them. Results is wrapped in an :ok tuple or else an :error tuple with reason is returned."},{"ref":"Brook.html#get_all_values!/2","title":"Brook.get_all_values!/2","type":"function","doc":"Returns a list of all values saved to a given collection of the Brook view state, independent of the key used to index them, or else raises an exception."},{"ref":"Brook.html#get_events/3","title":"Brook.get_events/3","type":"function","doc":"Returns a list of Brook events that produced the value stored under the given key within a collection from the Brook view state, wrapped in an :ok tuple or else an :error tuple with reason."},{"ref":"Brook.html#get_events!/3","title":"Brook.get_events!/3","type":"function","doc":"Returns a list of Brook events that produced the value stored under the given key within a collection from the Brook view state or else raises an exception."},{"ref":"Brook.html#start_link/1","title":"Brook.start_link/1","type":"function","doc":"Starts a Brook process linked to the current process."},{"ref":"Brook.html#t:author/0","title":"Brook.author/0","type":"type","doc":"The source application generating an event message"},{"ref":"Brook.html#t:event/0","title":"Brook.event/0","type":"type","doc":"The data component of an event message"},{"ref":"Brook.html#t:event_type/0","title":"Brook.event_type/0","type":"type","doc":"The catagory of event to contextualize the data of an event message"},{"ref":"Brook.html#t:instance/0","title":"Brook.instance/0","type":"type","doc":"The name of this instance of Brook"},{"ref":"Brook.html#t:reason/0","title":"Brook.reason/0","type":"type","doc":"The potential negative return value of a view state query."},{"ref":"Brook.html#t:view_collection/0","title":"Brook.view_collection/0","type":"type","doc":"The grouping of events by catagory for persisted view storage"},{"ref":"Brook.html#t:view_key/0","title":"Brook.view_key/0","type":"type","doc":"The index by which events are stored in a view state collection"},{"ref":"Brook.html#t:view_value/0","title":"Brook.view_value/0","type":"type","doc":"The event data stored within a view state collection, indexed by key"},{"ref":"Brook.Config.html","title":"Brook.Config","type":"module","doc":"Constructs a new Brook server config struct from a keyword list of inputs."},{"ref":"Brook.Config.html#child_spec/1","title":"Brook.Config.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Brook.Config.html#dispatcher/1","title":"Brook.Config.dispatcher/1","type":"function","doc":""},{"ref":"Brook.Config.html#driver/1","title":"Brook.Config.driver/1","type":"function","doc":""},{"ref":"Brook.Config.html#event_handlers/1","title":"Brook.Config.event_handlers/1","type":"function","doc":""},{"ref":"Brook.Config.html#get/2","title":"Brook.Config.get/2","type":"function","doc":""},{"ref":"Brook.Config.html#handle_continue/2","title":"Brook.Config.handle_continue/2","type":"function","doc":"Invoked to handle continue instructions. It is useful for performing work after initialization or for splitting the work in a callback in multiple steps, updating the process state along the way. Return values are the same as c:handle_cast/2. This callback is optional. If one is not implemented, the server will fail if a continue instruction is used. This callback is only supported on Erlang/OTP 21+. Callback implementation for GenServer.handle_continue/2."},{"ref":"Brook.Config.html#init/1","title":"Brook.Config.init/1","type":"function","doc":"Invoked when the server is started. start_link/3 or start/3 will block until it returns. init_arg is the argument term (second argument) passed to start_link/3. Returning {:ok, state} will cause start_link/3 to return {:ok, pid} and the process to enter its loop. Returning {:ok, state, timeout} is similar to {:ok, state} except handle_info(:timeout, state) will be called after timeout milliseconds if no messages are received within the timeout. Returning {:ok, state, :hibernate} is similar to {:ok, state} except the process is hibernated before entering the loop. See c:handle_call/3 for more information on hibernation. Returning {:ok, state, {:continue, continue}} is similar to {:ok, state} except that immediately after entering the loop the c:handle_continue/2 callback will be invoked with the value continue as first argument. Returning :ignore will cause start_link/3 to return :ignore and the process will exit normally without entering the loop or calling c:terminate/2. If used when part of a supervision tree the parent supervisor will not fail to start nor immediately try to restart the GenServer. The remainder of the supervision tree will be started and so the GenServer should not be required by other processes. It can be started later with Supervisor.restart_child/2 as the child specification is saved in the parent supervisor. The main use cases for this are: The GenServer is disabled by configuration but might be enabled later. An error occurred and it will be handled by a different mechanism than the Supervisor. Likely this approach involves calling Supervisor.restart_child/2 after a delay to attempt a restart. Returning {:stop, reason} will cause start_link/3 to return {:error, reason} and the process to exit with reason reason without entering the loop or calling c:terminate/2. Callback implementation for GenServer.init/1."},{"ref":"Brook.Config.html#new/1","title":"Brook.Config.new/1","type":"function","doc":"Take a keyword list and extracts values necessary to configure a Brook server. Provides default values for the driver and dipatcher but fails if event_handler or storage are not supplied by the user."},{"ref":"Brook.Config.html#put/3","title":"Brook.Config.put/3","type":"function","doc":""},{"ref":"Brook.Config.html#registry/1","title":"Brook.Config.registry/1","type":"function","doc":""},{"ref":"Brook.Config.html#start_link/1","title":"Brook.Config.start_link/1","type":"function","doc":""},{"ref":"Brook.Config.html#storage/1","title":"Brook.Config.storage/1","type":"function","doc":""},{"ref":"Brook.Dispatcher.html","title":"Brook.Dispatcher","type":"behaviour","doc":"Defines the Brook Dispatcher behaviour, requiring the init/0 and dispatch/1 functions be implemented by the client."},{"ref":"Brook.Dispatcher.html#c:dispatch/2","title":"Brook.Dispatcher.dispatch/2","type":"callback","doc":"Distributes received messages across multiple nodes."},{"ref":"Brook.Dispatcher.html#c:init/1","title":"Brook.Dispatcher.init/1","type":"callback","doc":"Start a Brook dispatcher."},{"ref":"Brook.Dispatcher.Default.html","title":"Brook.Dispatcher.Default","type":"module","doc":"Default implementation for the Brook.Dispatcher Creates and joins a process group named :brook_servers. Ensures all members of the process group receive notification of the received event by a member of the group."},{"ref":"Brook.Dispatcher.Default.html#dispatch/2","title":"Brook.Dispatcher.Default.dispatch/2","type":"function","doc":"Takes an event struct and forwards the event on to other member nodes of the :brook_servers process group after tagging the forwarded status of the event to true."},{"ref":"Brook.Dispatcher.Default.html#init/1","title":"Brook.Dispatcher.Default.init/1","type":"function","doc":"Creates and joins the Brook server to the process group named :brook_servers."},{"ref":"Brook.Dispatcher.Noop.html","title":"Brook.Dispatcher.Noop","type":"module","doc":""},{"ref":"Brook.Dispatcher.Noop.html#dispatch/2","title":"Brook.Dispatcher.Noop.dispatch/2","type":"function","doc":"Distributes received messages across multiple nodes. Callback implementation for Brook.Dispatcher.dispatch/2."},{"ref":"Brook.Dispatcher.Noop.html#init/1","title":"Brook.Dispatcher.Noop.init/1","type":"function","doc":"Start a Brook dispatcher. Callback implementation for Brook.Dispatcher.init/1."},{"ref":"Brook.Driver.html","title":"Brook.Driver","type":"behaviour","doc":"Defines the behaviour clients must implement in order to send events to the event stream. Ensures a child specification is defined and a process can be started and linked to the calling process, as well as sending serialized events with an accompanying event type for pattern matching to handle different types of events from a single client event handling module."},{"ref":"Brook.Driver.html#c:child_spec/1","title":"Brook.Driver.child_spec/1","type":"callback","doc":"Return a child specification for the Brook driver for inclusion in an application supervision tree."},{"ref":"Brook.Driver.html#c:send_event/3","title":"Brook.Driver.send_event/3","type":"callback","doc":"Send a Brook event to the event stream with a contextual event type and a data value serialized for transfer."},{"ref":"Brook.Driver.html#c:start_link/1","title":"Brook.Driver.start_link/1","type":"callback","doc":"Start a Brook driver and link to the current process."},{"ref":"Brook.Driver.html#t:serialized_event/0","title":"Brook.Driver.serialized_event/0","type":"type","doc":"Brook event message data encoded to a serialized format"},{"ref":"Brook.Driver.Default.html","title":"Brook.Driver.Default","type":"module","doc":"Default implmentation of the Brook.Driver behaviour. Simply casts the event to the Brook server by way of a registry lookup."},{"ref":"Brook.Driver.Default.html#child_spec/1","title":"Brook.Driver.Default.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Brook.Driver.Default.html#init/1","title":"Brook.Driver.Default.init/1","type":"function","doc":"Initializes the default Brook driver with an empty state."},{"ref":"Brook.Driver.Default.html#send_event/3","title":"Brook.Driver.Default.send_event/3","type":"function","doc":"Takes event data and casts to the Brook server to process."},{"ref":"Brook.Driver.Default.html#start_link/1","title":"Brook.Driver.Default.start_link/1","type":"function","doc":"Start the default Brooker driver GenServer and link it to the current process."},{"ref":"Brook.Driver.Kafka.html","title":"Brook.Driver.Kafka","type":"module","doc":"Implements the Brook.Driver behaviour for using Kafka as the message bus underlying the event stream. Brook&#39;s Kafka driver uses the (Elsa)[https://github.com/bbalser/elsa] library for subscribing to and sending messages to a Kafka topic handling event stream communication between distributed applications."},{"ref":"Brook.Driver.Kafka.html#child_spec/1","title":"Brook.Driver.Kafka.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Brook.Driver.Kafka.html#init/1","title":"Brook.Driver.Kafka.init/1","type":"function","doc":"Initialize the Elsa supervision tree for the consumer of the event stream topic."},{"ref":"Brook.Driver.Kafka.html#send_event/3","title":"Brook.Driver.Kafka.send_event/3","type":"function","doc":"Send Brook event messages to the event stream topic."},{"ref":"Brook.Driver.Kafka.html#start_link/1","title":"Brook.Driver.Kafka.start_link/1","type":"function","doc":"Start Brook.Driver and link to the current process"},{"ref":"Brook.Driver.Kafka.Handler.html","title":"Brook.Driver.Kafka.Handler","type":"module","doc":"Implements the Elsa message handler behaviour for the Brook Kafka driver."},{"ref":"Brook.Driver.Kafka.Handler.html#connection/0","title":"Brook.Driver.Kafka.Handler.connection/0","type":"function","doc":""},{"ref":"Brook.Driver.Kafka.Handler.html#generation_id/0","title":"Brook.Driver.Kafka.Handler.generation_id/0","type":"function","doc":""},{"ref":"Brook.Driver.Kafka.Handler.html#handle_messages/1","title":"Brook.Driver.Kafka.Handler.handle_messages/1","type":"function","doc":"Callback implementation for Elsa.Consumer.MessageHandler.handle_messages/1."},{"ref":"Brook.Driver.Kafka.Handler.html#handle_messages/2","title":"Brook.Driver.Kafka.Handler.handle_messages/2","type":"function","doc":"Takes a list of Kafka messages consumed by Elsa and processes each with Brook."},{"ref":"Brook.Driver.Kafka.Handler.html#init/1","title":"Brook.Driver.Kafka.Handler.init/1","type":"function","doc":"Callback implementation for Elsa.Consumer.MessageHandler.init/1."},{"ref":"Brook.Driver.Kafka.Handler.html#partition/0","title":"Brook.Driver.Kafka.Handler.partition/0","type":"function","doc":""},{"ref":"Brook.Driver.Kafka.Handler.html#topic/0","title":"Brook.Driver.Kafka.Handler.topic/0","type":"function","doc":""},{"ref":"Brook.Driver.Test.html","title":"Brook.Driver.Test","type":"module","doc":""},{"ref":"Brook.Driver.Test.html#child_spec/1","title":"Brook.Driver.Test.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Brook.Driver.Test.html#init/1","title":"Brook.Driver.Test.init/1","type":"function","doc":"Invoked when the server is started. start_link/3 or start/3 will block until it returns. init_arg is the argument term (second argument) passed to start_link/3. Returning {:ok, state} will cause start_link/3 to return {:ok, pid} and the process to enter its loop. Returning {:ok, state, timeout} is similar to {:ok, state} except handle_info(:timeout, state) will be called after timeout milliseconds if no messages are received within the timeout. Returning {:ok, state, :hibernate} is similar to {:ok, state} except the process is hibernated before entering the loop. See c:handle_call/3 for more information on hibernation. Returning {:ok, state, {:continue, continue}} is similar to {:ok, state} except that immediately after entering the loop the c:handle_continue/2 callback will be invoked with the value continue as first argument. Returning :ignore will cause start_link/3 to return :ignore and the process will exit normally without entering the loop or calling c:terminate/2. If used when part of a supervision tree the parent supervisor will not fail to start nor immediately try to restart the GenServer. The remainder of the supervision tree will be started and so the GenServer should not be required by other processes. It can be started later with Supervisor.restart_child/2 as the child specification is saved in the parent supervisor. The main use cases for this are: The GenServer is disabled by configuration but might be enabled later. An error occurred and it will be handled by a different mechanism than the Supervisor. Likely this approach involves calling Supervisor.restart_child/2 after a delay to attempt a restart. Returning {:stop, reason} will cause start_link/3 to return {:error, reason} and the process to exit with reason reason without entering the loop or calling c:terminate/2. Callback implementation for GenServer.init/1."},{"ref":"Brook.Driver.Test.html#send_event/3","title":"Brook.Driver.Test.send_event/3","type":"function","doc":"Send a Brook event to the event stream with a contextual event type and a data value serialized for transfer. Callback implementation for Brook.Driver.send_event/3."},{"ref":"Brook.Driver.Test.html#start_link/1","title":"Brook.Driver.Test.start_link/1","type":"function","doc":"Start a Brook driver and link to the current process. Callback implementation for Brook.Driver.start_link/1."},{"ref":"Brook.Driver.Test.html#via/1","title":"Brook.Driver.Test.via/1","type":"function","doc":""},{"ref":"Brook.Event.html","title":"Brook.Event","type":"module","doc":"The Brook.Event struct is the basic unit of message written to and read from the event stream. It encodes the type of event (for application event handlers to pattern match on), the author (source application), The creation timestamp of the message, the actual data of the message, and a boolean detailing if the message was forwarded within the Brook Server process group. The data component of the message is an arbitrary Elixir term but is typically a map or struct."},{"ref":"Brook.Event.html#new/1","title":"Brook.Event.new/1","type":"function","doc":""},{"ref":"Brook.Event.html#process/2","title":"Brook.Event.process/2","type":"function","doc":"Process a Brook.Event struct via synchronous call to the Brook.Server"},{"ref":"Brook.Event.html#send/4","title":"Brook.Event.send/4","type":"function","doc":"Send a message to the Brook.Server synchronously, passing the term to be encoded into a Brook.Event struct, the authoring application, and the type of event. The event type must implement the String.Chars.t type."},{"ref":"Brook.Event.html#send/5","title":"Brook.Event.send/5","type":"function","doc":""},{"ref":"Brook.Event.html#update_data/2","title":"Brook.Event.update_data/2","type":"function","doc":"Takes a Brook.Event struct and a function and updates the data value of the struct based on the outcome of applying the function to the incoming data value. Merges the resulting data value back into the struct."},{"ref":"Brook.Event.html#t:data/0","title":"Brook.Event.data/0","type":"type","doc":""},{"ref":"Brook.Event.html#t:driver/0","title":"Brook.Event.driver/0","type":"type","doc":""},{"ref":"Brook.Event.html#t:t/0","title":"Brook.Event.t/0","type":"type","doc":""},{"ref":"Brook.Event.Handler.html","title":"Brook.Event.Handler","type":"behaviour","doc":"Defines the Brook.Event.Handler behaviour that an application is expected to provide for processing events off the event stream via Brook, as well as a default implementation."},{"ref":"Brook.Event.Handler.html#__before_compile__/1","title":"Brook.Event.Handler.__before_compile__/1","type":"macro","doc":"Simple default handle_event/1 implementation that discards the message and takes no other action."},{"ref":"Brook.Event.Handler.html#__using__/1","title":"Brook.Event.Handler.__using__/1","type":"macro","doc":"A using macro to define a module as implementing the Brook.Event.Handler behaviour and supply a default implementation of the required handle_event/1 function."},{"ref":"Brook.Event.Handler.html#c:handle_event/1","title":"Brook.Event.Handler.handle_event/1","type":"callback","doc":"Process incoming events from the event stream and return a result with optional persistence of values to the application view state."},{"ref":"Brook.Event.Handler.html#t:create/0","title":"Brook.Event.Handler.create/0","type":"type","doc":"The return value of a create operation to save a value to the view state"},{"ref":"Brook.Event.Handler.html#t:delete/0","title":"Brook.Event.Handler.delete/0","type":"type","doc":"The return value of a delete operation to remove a value from the view state"},{"ref":"Brook.Event.Handler.html#t:discard/0","title":"Brook.Event.Handler.discard/0","type":"type","doc":"The return value of an event that should not persist any result to the view state."},{"ref":"Brook.Event.Handler.html#t:merge/0","title":"Brook.Event.Handler.merge/0","type":"type","doc":"The return value of merging a new value into the existing value with the view state saved under a given key and collection."},{"ref":"Brook.InvalidEvent.html","title":"Brook.InvalidEvent","type":"exception","doc":"An exception that is raised when no valid event can be found."},{"ref":"Brook.InvalidInstance.html","title":"Brook.InvalidInstance","type":"exception","doc":"An exception that is raised when an instance of brook cannot be found."},{"ref":"Brook.Server.html","title":"Brook.Server","type":"module","doc":"Process event messages to and from the underlying event stream message bus implementation. Interact with the application&#39;s persisted view state of the event stream with getter and setter functions to write and update events from the view state as well as delete them."},{"ref":"Brook.Server.html#child_spec/1","title":"Brook.Server.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Brook.Server.html#init/1","title":"Brook.Server.init/1","type":"function","doc":"Initialize a Brook server configuration."},{"ref":"Brook.Server.html#start_link/1","title":"Brook.Server.start_link/1","type":"function","doc":"Start a Brook server and link it to the current process"},{"ref":"Brook.Storage.html","title":"Brook.Storage","type":"behaviour","doc":"Defines the Brook.Storage behaviour that must be implemented by storage driver processes. Starts a process and defines a child specification for including the driver in Brook&#39;s supervision tree. Implements the CRUD functionality for persisting events to the application view state within the storage driver and subsequent retrieval."},{"ref":"Brook.Storage.html#c:child_spec/1","title":"Brook.Storage.child_spec/1","type":"callback","doc":"Define a child specification for including the storage driver in the Brook supervision tree."},{"ref":"Brook.Storage.html#c:delete/3","title":"Brook.Storage.delete/3","type":"callback","doc":"Delete the record of a saved value from the view state within a given collection and identified by a given key."},{"ref":"Brook.Storage.html#c:get/3","title":"Brook.Storage.get/3","type":"callback","doc":"Return a value from the persisted view state stored within a collection and identified by a key."},{"ref":"Brook.Storage.html#c:get_all/2","title":"Brook.Storage.get_all/2","type":"callback","doc":"Return all values saved to the application view state within the storage system under a given collection. Events are returned as a map with the identifying keys as keys and the saved values as values."},{"ref":"Brook.Storage.html#c:get_events/3","title":"Brook.Storage.get_events/3","type":"callback","doc":"Return a list of events that produced a value saved to the application view state within the storage system under a given collection and idetifying key."},{"ref":"Brook.Storage.html#c:persist/5","title":"Brook.Storage.persist/5","type":"callback","doc":"Save a value from a processed event to the application view state stored on the underlying storage system. Events are saved to a collection of related events under a given identifying key. The event is simultaneously stored under a different key to serve as a log of all events that produced or modified the value saved to the given key and collection."},{"ref":"Brook.Storage.html#c:start_link/1","title":"Brook.Storage.start_link/1","type":"callback","doc":"Start the storage driver and link it to the current process."},{"ref":"Brook.Storage.Ets.html","title":"Brook.Storage.Ets","type":"module","doc":"Implements the Brook.Storage behaviour for ETS, saving the application view state to the in-memory Erlang key/value datastore. As ETS is in-memory, this implementation is intended for testing purposes and not recommended for production persistence of application data."},{"ref":"Brook.Storage.Ets.html#child_spec/1","title":"Brook.Storage.Ets.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Brook.Storage.Redis.html","title":"Brook.Storage.Redis","type":"module","doc":"Implements the Brook.Storage behaviour for the Redis key/value storage system, saving the application view state as binary encodings of the direct Elixir terms to be saved with maximum compression."},{"ref":"Brook.Storage.Redis.html#child_spec/1","title":"Brook.Storage.Redis.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Brook.Storage.Redis.html#t:config/0","title":"Brook.Storage.Redis.config/0","type":"type","doc":""},{"ref":"Brook.Storage.Redis.Migration.html","title":"Brook.Storage.Redis.Migration","type":"module","doc":""},{"ref":"Brook.Storage.Redis.Migration.html#migrate/4","title":"Brook.Storage.Redis.Migration.migrate/4","type":"function","doc":""},{"ref":"Brook.Supervisor.html","title":"Brook.Supervisor","type":"module","doc":"A Brook application supervisor, managing the process registry, storage and driver module processes, and the server process."},{"ref":"Brook.Supervisor.html#child_spec/1","title":"Brook.Supervisor.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Brook.Supervisor.html#init/1","title":"Brook.Supervisor.init/1","type":"function","doc":"Initialize the Brook supervisor with all necessary child processes."},{"ref":"Brook.Supervisor.html#start_link/1","title":"Brook.Supervisor.start_link/1","type":"function","doc":"Start a Brook supervisor and link it to the current process."},{"ref":"Brook.Test.html","title":"Brook.Test","type":"module","doc":""},{"ref":"Brook.Test.html#clear_view_state/2","title":"Brook.Test.clear_view_state/2","type":"function","doc":""},{"ref":"Brook.Test.html#register/1","title":"Brook.Test.register/1","type":"function","doc":""},{"ref":"Brook.Test.html#send/4","title":"Brook.Test.send/4","type":"function","doc":""},{"ref":"Brook.Test.html#with_event/2","title":"Brook.Test.with_event/2","type":"function","doc":""},{"ref":"Brook.Test.html#with_event/3","title":"Brook.Test.with_event/3","type":"function","doc":""},{"ref":"Brook.Uninitialized.html","title":"Brook.Uninitialized","type":"exception","doc":"An exception that is raised when calls are made to retrieve values from the view state, but Brook is Uninitialized."},{"ref":"Brook.ViewState.html","title":"Brook.ViewState","type":"module","doc":""},{"ref":"Brook.ViewState.html#commit/1","title":"Brook.ViewState.commit/1","type":"function","doc":""},{"ref":"Brook.ViewState.html#create/3","title":"Brook.ViewState.create/3","type":"function","doc":""},{"ref":"Brook.ViewState.html#delete/2","title":"Brook.ViewState.delete/2","type":"function","doc":""},{"ref":"Brook.ViewState.html#get/3","title":"Brook.ViewState.get/3","type":"function","doc":""},{"ref":"Brook.ViewState.html#get_all/2","title":"Brook.ViewState.get_all/2","type":"function","doc":""},{"ref":"Brook.ViewState.html#init/1","title":"Brook.ViewState.init/1","type":"function","doc":""},{"ref":"Brook.ViewState.html#merge/3","title":"Brook.ViewState.merge/3","type":"function","doc":""},{"ref":"Brook.ViewState.html#rollback/1","title":"Brook.ViewState.rollback/1","type":"function","doc":""}]